From c771b632171b704acebdcc0234a46c1c019fda71 Mon Sep 17 00:00:00 2001
From: Francois Andrieu <darknao@fedoraproject.org>
Date: Feb 05 2022 18:15:51 +0000
Subject: [PATCH 73/88] extension to retrieve last-update information from git


---

diff --git a/build-scripts/rebuild-site.py b/build-scripts/rebuild-site.py
index aad83d5..468dbbb 100755
--- a/build-scripts/rebuild-site.py
+++ b/build-scripts/rebuild-site.py
@@ -111,6 +111,20 @@ def generate_lang_switch_ui(languages):
 
     return "\n".join(template_list)
 
+def prefetch_sources(original_sources, site_yml, config):
+    if not os.path.isdir(original_sources):
+        os.mkdir(original_sources)
+
+    for repo_data in site_yml["content"]["sources"]:
+      gitdir = tempfile.TemporaryDirectory(dir=original_sources)
+      dirname = gitdir.name
+      gitdir.cleanup()
+      log(f"Fetching {repo_data['url']}...")
+      subprocess.run(["git", "clone", repo_data['url'], dirname])
+      repo_data['url'] = dirname
+
+    return site_yml
+
 def prepare_translated_sources(translated_sources, site_yml, languages, config):
     with tempfile.TemporaryDirectory() as workdir:
         # Location of the translated-sources repo
@@ -320,9 +334,23 @@ def main():
         if config["build_langs"] == "english" or config["build_langs"] == "all":
 
             log("")
+            log("===== Prefetching all components =====")
+            original_sources = os.path.join(workdir, "orginal_sources")
+            site_local = prefetch_sources(original_sources, original_site_yml, config)
+            log(original_site_yml["content"]["sources"][0]['url'])
+            log(site_local["content"]["sources"][0]['url'])
+
+            filename = os.path.join(docs_repo, "site-local.yml")
+            with open(filename, "w") as file:
+                file.write(yaml.dump(site_local))
+
+            
+
+            log("")
             log("===== Building the en-US site =====")
             antora_env["ANTORA_LANGUAGE"] = "en-US"
-            result = subprocess.run(["antora", "--html-url-extension-style=indexify", os.path.join(docs_repo, "site.yml")], env=antora_env)
+            # result = subprocess.run(["antora", "--html-url-extension-style=indexify", os.path.join(docs_repo, "site.yml")], env=antora_env)
+            result = subprocess.run(["antora", "--html-url-extension-style=indexify", filename], env=antora_env)
 
             if result.returncode != 0:
                 log("ERROR building the en-US site")
diff --git a/lib/extensions/page-last-update.js b/lib/extensions/page-last-update.js
new file mode 100644
index 0000000..a2bfaf2
--- /dev/null
+++ b/lib/extensions/page-last-update.js
@@ -0,0 +1,29 @@
+
+module.exports.register = function () {
+  this.on('contentClassified', async ({ contentCatalog }) => {
+      const logger = this.require('@antora/logger').get('page-last-update')
+      const git = this.require('@antora/content-aggregator/lib/git')
+      const path = this.require('path')
+      const fs = this.require('fs')
+      // logger.warn(contentCatalog)
+
+      const pages = contentCatalog.findBy({ family: 'page' })
+      for (const module of pages) {
+	    const relpath = path.join(module.src.origin.startPath, module.src.path)
+            logger.warn(relpath)
+            // logger.warn(module.src)
+	    const contents = module.contents.toString('utf-8')
+
+            // logger.warn(module.contents)
+	    const commits = await git.log({ fs, gitdir: module.src.origin.gitdir, filepath: relpath, ref: "origin/"+module.src.origin.refname, follow: true, depth: 1 })
+	    const last_update = new Date(commits[0].commit.author.timestamp * 1000).toISOString().split('T')[0]
+	    const last_author = commits[0].commit.author.name
+            // logger.warn(commits)
+            // logger.warn({ name: relpath, created_at: created_at, last_update: last_update, by: last_author })
+	    const patchedContents = ":page-last-updated: " + last_update + "\n" + contents
+	    module.contents = Buffer.from(patchedContents)
+
+      }
+      this.updateVariables({ contentCatalog })
+    })
+}
